//  Pinball Dreams high score hack.
//  Modifies the game to save high scores to SRAM.
//  Quick edit of the original Pinball Fantasies patch
//  Source code for use with xkas v14
//  d@revenant1.net / 05 Mar 2011

arch snes.cpu; lorom

org $ffd6 	// change ROM type to ROM/SRAM
	db	$02
org $ffd8	// set SRAM size to 16 Kbit
	db	$01
	
org $f4b0
LoadScores:
	phx
	pha
	php
	sep	#$30	//use 8bit registers
	
	lda	$4219
	and.b	#%00100000	//select -> ignore saved scores
	ora	$700000	// first byte of SRAM says whether or not saved scores exist	
	sta	$700000

	// A = $01 	-> select not pressed, scores previously saved, now load them
	// else		-> ignore SRAM, use default high scores from ROM

	cmp	#$01
	bne	+
	
	ldx	#$8f	// start copying high score table
-;	lda	$700000,x
	sta	$1a12,x
	dex
	bne	-
	
	// jump back to title screen fade-up
+;	plp
	pla
	plx
	jmp	$9312
	
SaveScores:
	phx
	pha
	php
	sep	#$30

	lda	#$01	// set the "scores saved" flag
	sta	$700000
	
	ldx	#$8f	// start saving the score table
-;	lda	$1a12,x
	sta	$700000,x
	dex
	bne -
	
	// jump back to game over sequence
	plp
	pla
	plx
	jmp 	$b7e2 
	
//  replace some jumps in the game
org $b18b 	//during first screen fade-in
	jmp	LoadScores	
	
org $97ad  	//game over, after initials entered at hiscore
	jsr	SaveScores	